<script setup lang="ts">
import { ref, computed, onMounted, onUnmounted } from "vue";
import type { Ref, CSSProperties } from "vue";
import { getFocusableChildren, isTabPressed, isEscPressed } from "@/utils/dom";
import { onClickOutside } from "@vueuse/core";

const props = defineProps<{
  styles?: CSSProperties;
}>();

const modalStyles = computed(() => {
  const defaults: CSSProperties = {
    maxHeight: "100vh",
    overflowY: "auto",
    backgroundColor: "var(--color-light)",
    borderRadius: "1.2rem",
    width: "min(62rem, 85vw)",
  };

  return props.styles ? Object.assign(defaults, props.styles) : defaults;
});

const emit = defineEmits<{
  (e: "close-modal"): void;
}>();

const modal: Ref<HTMLDivElement | null> = ref(null);

onClickOutside(modal, () => emit("close-modal"));

onMounted(() => {
  if (!modal.value) {
    return;
  }

  document.body.style.overflow = "hidden";

  const focusableModalChildren = getFocusableChildren(modal.value);
  const firstFocusableModalChild = focusableModalChildren[0];
  const lastFocusableModalChild =
    focusableModalChildren[focusableModalChildren.length - 1];

  if (!(firstFocusableModalChild instanceof HTMLElement)) {
    return;
  }

  keydownHandler = getKeydownHandler(
    firstFocusableModalChild,
    lastFocusableModalChild instanceof HTMLElement
      ? lastFocusableModalChild
      : firstFocusableModalChild
  );

  document.addEventListener("keydown", keydownHandler);
});

onUnmounted(() => {
  document.body.style.overflow = "auto";

  if (!keydownHandler) {
    return;
  }

  document.removeEventListener("keydown", keydownHandler);
});

let keydownHandler: (e: KeyboardEvent) => void | null;

function getKeydownHandler(
  firstFocusableEl: HTMLElement,
  lastFocusableEl: HTMLElement
) {
  return function (e: KeyboardEvent) {
    if (
      !modal.value ||
      !(modal.value instanceof HTMLElement) ||
      !(e.target instanceof Node)
    ) {
      return;
    }

    if (!isTabPressed(e)) {
      if (isEscPressed(e)) {
        return emit("close-modal");
      }

      return;
    }

    const isFocusGoingOutside = !modal.value.contains(e.target);

    if (isFocusGoingOutside) {
      if (e.shiftKey) {
        lastFocusableEl.focus();
      } else {
        firstFocusableEl.focus();
      }
      e.preventDefault();
      return;
    }

    // if we are not dealing with either the first or the last element,
    // then we want the default action to happen
    if (e.shiftKey) {
      if (document.activeElement === firstFocusableEl) {
        lastFocusableEl.focus();
        e.preventDefault();
      }
    } else {
      if (document.activeElement === lastFocusableEl) {
        firstFocusableEl.focus();
        e.preventDefault();
      }
    }
  };
}
</script>

<template>
  <Teleport to="body">
    <div class="modal-wrapper">
      <div class="modal-inner" ref="modal" :style="modalStyles">
        <slot></slot>
      </div>
    </div>
  </Teleport>
</template>

<style lang="scss" scoped>
@use "@/assets/styles/bootstrap";

.modal-wrapper {
  position: fixed;
  z-index: 9999;
  top: 0;
  left: 0;
  width: 100%;
  height: 100%;
  background-color: var(--color-dim-background);
  display: grid;
  place-content: center;
}
</style>
